#!/usr/bin/env python
# Copyright (C) 2006 Eitan Isaacson <eitan@ascender.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import pygtk
pygtk.require('2.0')
import gtk
from gnome import url_show
import flickrlib

class AuthDialog:
	agent = flickrlib.FlickrAgent('48197b3ff4fb6f9d1caa650cb05764dd','96d5319a6da0f358')
	
	def cancel(self, widget, data):
		gtk.main_quit()

	def goto_url(self, widget, data):
		if not url_show(data):
			raise Exception
		mesg = '''<b>Return to this window after you have finished the authorization process on Flickr.com</b>

<i>(You can revoke Gnickr's authorization at any time in your account page on Flickr.com)</i>'''
		self.message.set_markup(mesg)
		widget.disconnect(self.b1handler)
		widget.set_use_stock(True)
		gtk.stock_add([(gtk.STOCK_APPLY, "Complete Authorization", 0, 0, "")])
		widget.set_label(gtk.STOCK_APPLY)
		self.b1handler = widget.connect("clicked", self.retrieve_token, None)
		
	def retrieve_token(self, widget, data):
		self.agent.retrieveToken()
		self.agent.flickr.test.login()
		self.agent.saveToken()
		mesg = '''<b>Done!</b>
		
You can now use Gnickr to manage your Flickr photos'''
		self.message.set_markup(mesg)
		widget.disconnect(self.b1handler)
		widget.set_use_stock(True)
		widget.set_label(gtk.STOCK_OK)
		widget.connect("clicked", self.cancel, None)

	def delete_event(self, widget, event, data=None):
		gtk.main_quit()
		return False

	def __init__(self):
		# Create a new window
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window = gtk.Dialog(title="Authorize Gnickr", parent=None, flags=0, buttons=None)

		self.window.connect("delete_event", self.delete_event)

		mesg = '''<b>Gnickr requires your authorization before it cat read or modify your photos and data on Flickr</b>

Authorizing is a simple process which takes place in your web browser. When you're finished, return to this window to complete authorization and begin using Gnickr.

<i>(You must be connected to the internet in order to authorize this program)</i>'''
		
		self.message = gtk.Label()
#		self.message.set_max_width_chars(20)
		self.message.set_line_wrap(True)
		self.message.set_markup(mesg)

		self.window.vbox.pack_start(self.message, True, True,0)
		gtk.stock_add([(gtk.STOCK_EXECUTE, "Authorize", 0, 0, "")])
		self.button1 = gtk.Button(stock=gtk.STOCK_EXECUTE)
		
		self.b1handler = self.button1.connect("clicked", self.goto_url, self.agent.authLoginURL('delete'))

		self.button2 = gtk.Button(stock=gtk.STOCK_CANCEL)

		self.button2.connect("clicked", self.cancel, None)
		
		self.window.action_area.pack_start(self.button1, True, True, 0)
		self.window.action_area.pack_start(self.button2, True, True, 0)

		self.message.show()
		self.button1.show()
		self.button2.show()
		self.window.show()

def main():
    gtk.main()

hello = AuthDialog()
main()
