#!/usr/bin/env python
#
# Copyright (C) 2006 Eitan Isaacson <eitan@ascender.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from PIL import Image, ImageFile, ImageChops
from sys import argv
import gnomevfs
from urllib import urlopen

uri = gnomevfs.URI(argv[1])
p = ImageFile.Parser()
if not uri.scheme.count('flickr'):
	src = gnomevfs.open(argv[1])
	buf = ''
	while 1:
		try:
			buf += src.read(1024)
		except gnomevfs.EOFError:
			break
	p.feed(buf)
	im = p.close()
	im.thumbnail((int(argv[2]),int(argv[2])), Image.ANTIALIAS)
	im.save(argv[3],'PNG')

else:
	src = urlopen(gnomevfs.get_file_info(uri).symlink_name)
	while 1:
		buf = src.read(1024)
		if not buf:
			break
		p.feed(buf)
	im = p.close()
	w,h = im.size
	im.thumbnail((int(argv[2]),int(argv[2])), Image.ANTIALIAS)
	im.resize((int(w*1.28),int(h*1.28)), Image.ANTIALIAS).save(argv[3],'PNG')

